QGIS Application - Bug report #8572
PostGIS Geography Type, ERROR: Invalid geography
2013-09-04 12:35 PM - Denver Pierce

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/PostGIS

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 17317
Description

Loading geography types in Master by adding a PostGIS Layer, nothing is displayed and the following log is given:

Query: DECLARE qgisf0_0 BINARY CURSOR FOR SELECT
st_asbinary(st_force_2d("pos"::geometry),'NDR'),"id" FROM
"public"."locations" WHERE "pos" && st_makeenvelope(-180,-90,180,90,4326)
returned 7 [ERROR: Invalid geography. Antipodal (180 degrees long) edge
(180 -90,180 90) detected, add a point between to make two edges that span
less than 180 degrees.]

Relevant stack exchange post:
http://gis.stackexchange.com/questions/70556/error-invalid-geography-antipodal-edge-with-postgis ?noredirect=1#comment96122 705
6

And post on the list:
http://0sgeo-org.1560.x6.nabble.com/geometry-with-geography-type-column-not-displayed-td4690688.html#a4690860

It seems the BBOX query is being cast to geography, then that is being sent back as invalid as it contains a banned antipodal query on a
geography.

CREATE TABLE global_points (
id SERIAL PRIMARY KEY,
name VARCHAR(64),
location GEOGRAPHY (POINT,4326)
);
INSERT INTO global_points (name, location) VALUES ('freiburg’, ST_GeographyFromText('POINT(7.86 48.0)"));
CREATE INDEX global_points_gix ON global_points USING GIST ( location );

Associated revisions

Revision 90b3efb9 - 2015-06-26 04:55 PM - Jiirgen Fischer

postgres provider: also cast geography to geometry when using && (fixes #8572)

Revision 3792afdb - 2015-07-19 09:01 PM - Jiirgen Fischer

postgres provider: also cast geography to geometry when using && (fixes #8572)

(cherry picked from commit 90b3efb93dd0b6460ce496a8acd7fcbf34b22f63)
History

#1 - 2013-10-04 09:14 AM - Sandro Santilli

Casting the geography to a geometry would fix this:
WHERE "location"::geometry && ...

Jef: was this that you had in mind when you asked about casting to geometry ?

#2 - 2013-10-04 09:29 AM - Sandro Santilli

I've filed an upstream bug as the workaround suggested by the error message (adding in-between point) doesn't help:

http://trac.osgeo.org/postgis/ticket/2495

#3 - 2015-06-26 04:19 AM - Jonathan Moules

This still happens with 2.6.1. I'm surprised the priority is so low given it makes QGIS useless with many PostGIS datasets.

#4 - 2015-06-26 07:56 AM - Jirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"90b3efb93dd0b6460ce496a8acd7fcbf34b22f63".
